////////////////////////////////////////////////////////////////////////////////
//	電卓ガジェット
//		Copyright (C) 2008 - 2009 AAOh inc.
////////////////////////////////////////////////////////////////////////////////

// 設定情報(JSON)
var settingData = {
	"bg"         : "onDoc1",
	"camma"      : true,
	"lang"       : "ja",
	"chkUpdTime" : 0,
	"chkUpdUrl"  : null
};

// 計算書式
var calcValue = "";

// 計算処理後フラグ
var flgCalc = false;

// 定数演算子
var constSign = "";

// 定数数値
var constNum = "";

// 定数使用フラグ
var flgConst = true;

// スタック演算子
var stackSign = "";

// スタック数値
var stackNum = "";

// デフォルトクラス名マップ
var mapClass = new Array();

var flgOnDoc = true;

var updChkIid = null;

/**
 * 計算処理。
 */
function doCalc(){
	if(calcValue == "" && stackSign == "" && stackNum == ""){
		return;
	}

	// 定数使用判定
	var tmpValue = calcValue + stackSign + stackNum;
	if(flgConst){
		if(stackSign != ""){
			tmpValue = tmpValue + constNum;
			if(stackSign == "-"){
				tmpValue = "(" + tmpValue + ")*-1";
			}

		} else {
			tmpValue = tmpValue + constSign + constNum;
		}
	}

	var ans = calculate(tmpValue);
	if(ans == null){
		doError();
		return;
	}

	if(!flgConst){
		constSign = stackSign;
		constNum  = stackNum;
	}

	calcValue = "";
	stackSign = "";
	stackNum  = String(ans);
	flgCalc   = true;
	flgConst  = true;

	showCalc(String(ans));
}

/**
 * エラー。
 */
function doError(){
	calcValue = "";
	flgCalc   = false;
	stackSign = "";
	stackNum  = "";
	flgConst  = true;

	$("txt_calc").value = getLocalizedString("MSG_ERROR");
	doSoundBeep();
}

/**
 * 値のクリア。
 */
function doClear(){
	calcValue = "";
	flgCalc   = false;
	constSign = "";
	constNum  = "";
	flgConst  = true;
	stackSign = "";
	stackNum  = "";

	showCalc(calcValue);
}

/**
 * 値をひとつ戻す。
 */
function doBack(){
	if(stackNum == ""){
		return;
	}

	stackNum = stackNum.substring(0, stackNum.length - 1);
	flgCalc  = false;

	showCalc(stackNum);
}

/**
 * "+/-"を行う。
 */
function doMinus(){
	flgConst = false;

	var tmpConst = flgConst
	var tmpSign  = stackSign;
	var tmpNum   = calcValue;
	doCalc();

	if(!tmpConst){
		constSign = tmpSign;
		constNum  = tmpNum;
	}

	var ans = calculate(stackNum + "*-1");
	if(ans == null){
		doError();
		return;
	}

	calcValue = "";
	stackSign = "";
	stackNum  = String(ans);
	flgCalc   = true;
	flgConst  = true;

	showCalc(String(ans));
}

/**
 * "%"を行う。
 */
function doPersent(){
	var tmpConst = flgConst
	var tmpSign  = stackSign;
	var tmpNum1  = calcValue;
	var tmpNum2  = stackNum;

	var tmpValue = null;
	if(tmpSign == "+" || tmpSign == "-"){

		stackNum = calcValue + tmpSign
			+ calcValue + "*" + stackNum + "*0.01";
		tmpValue = "";

	} else {

		doCalc();
		if(tmpSign == "/"){
			tmpValue = "*100";
		} else {
			tmpValue = "*0.01";
		}
	} // if(tmpSign == "+" || tmpSign == "-")

	if(!tmpConst){
		constSign = tmpSign;

		if(tmpSign == "/"){
			constNum = tmpNum2;
		} else {
			constNum = tmpNum1;
		}
	}

	var ans = calculate(stackNum + tmpValue);
	if(ans == null){
		doError();
		return;
	}

	calcValue = "";
	stackSign = "";
	stackNum  = String(ans);
	flgCalc   = true;
	flgConst  = true;

	showCalc(String(ans));
}

/**
 * クリップボードへコピーを行う。
 */
function doCopy(){
	if($("img_copy").className == "hide"){
		// 非表示だったら抜ける
		return;
	}
	var txtTmp = $("txt_tmp");

	// カンマを取除く
	txtTmp.value = $("txt_calc").value.replace(/,/g, "");

	// コピー
	try{
		if(isDashboard()){
			widget.system("/bin/echo -n '" + txtTmp.value + "' | /usr/bin/pbcopy", null);

		} else {
			var copyObj = txtTmp.createTextRange();
			copyObj.execCommand("Copy");
		}
	}catch(ex){
	}

	txtTmp.value = "";
}

/**
 * クリップボードからのペーストを行う。
 */
function doPaste(){
	if($("img_paste").className == "hide"){
		// 非表示だったら抜ける
		return;
	}
	var txtTmp = $("txt_tmp");

	// ペースト
	try{
		if(isDashboard()){
			txtTmp.value = widget.system("/usr/bin/pbpaste", null).outputString;

		} else {
			var pasteObj = txtTmp.createTextRange();
			pasteObj.execCommand("Paste");
		}
	}catch(ex){
	}

	// 数字以外を取除く
	var tmp = txtTmp.value.replace(/[^0-9\+\-\*\/\.]/g, "");
	if(tmp == null || tmp == ""){
		doError();
		txtTmp.value = "";
		return;
	}

	stackNum = stackNum + tmp;
	flgConst = false;
	doCalc();
	txtTmp.value = "";
}

/**
 * 計算記号の追加。
 *
 * @param value 計算記号
 */
function addSign(value){
	if(calcValue == "" && stackSign == "" && stackNum == ""){
		// 最初にマイナス入力対応
		if(value == "-"){
			addNumber("-");
			return;

		} else {
			return;
		}
	}

	// 定数設定
	if(stackSign != "" && stackNum == ""){
		flgCalc   = true;
		constSign = value;
		constNum  = calcValue;
		flgConst  = true;
		stackSign = "";

		if(value == "/"){
			calcValue = "1";
		}
		return;
	}

	var ans = calculate(calcValue + stackSign + stackNum);
	if(ans == null){
		doError();
		return;
	}

	if(calcValue != ""){
		flgConst = false;
	}

	calcValue = String(ans);
	flgCalc   = false;
	stackSign = value;
	stackNum  = "";

	showCalc(String(ans));
}

/**
 * 数字の追加。
 *
 * @param value 数字
 */
function addNumber(value){
	if(flgCalc){
		calcValue = "";
		stackNum  = value;
		flgCalc   = false;

	} else {
		stackNum = stackNum + value;

		// 有効桁数チェック
		stackNum = checkMaxLengthString(stackNum);
	}

	if(stackSign != ""){
		flgConst = false;
	}

	showCalc(stackNum);
}

/**
 * キー入力。
 *
 * @param event イベント
 */
function setImgInput(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		return;
	}

	// コントロールが押されている
	if(event.ctrlKey){
		setImgInputCtrl(event);
		return;
	}

	// シフトが押されている
	if(event.shiftKey){
		setImgInputShift(event);
		return;
	}

	switch(key){
		// "="
		case 13:
			setPushBtn("btn_equal");
			break;

		// "C"
		case 27:
		case 46:
			setPushBtn("btn_clear");
			break;

		// "Back"
		case 8:
			setPushBtn("btn_back");
			break;

		// "/"
		case 191:
		case 111:
		case 47: // opera対応
			setPushBtn("btn_div");
			break;

		// "*"
		case 106:
		case 42: // opera対応
			setPushBtn("btn_multi");
			break;

		// "-"
		case 109:
		case 189:
		case 45: // opera対応
			setPushBtn("btn_sub");
			break;

		// "+"
		case 107:
		case 43: // opera対応
		case 61: // opera対応(mac opera)
			setPushBtn("btn_add");
			break;

		// テンキー(数字)
		case  96:
		case  97:
		case  98:
		case  99:
		case 100:
		case 101:
		case 102:
		case 103:
		case 104:
		case 105:
			key = key - 48;

		// 数字
		case 48:
		case 49:
		case 50:
		case 51:
		case 52:
		case 53:
		case 54:
		case 55:
		case 56:
		case 57:
			var value = String.fromCharCode(key);
			setPushBtn("btn_" + value);
			break;

		// "."
		case 110:
		case 190:
		case 46: // opera対応
		case 78: // opera対応
			setPushBtn("btn_dott");
			break;

		default:
			break;
	}
}

/**
 * キー入力。
 *
 * @param event イベント
 */
function setImgInputCtrl(event){
	var key = event.keyCode;

	switch(key){
		// "Ctrl + C"
		case 67:
		// "Ctrl + Ins"
		case 45:
			setPushImg("img_copy");
			break;

		// "Ctrl + V"
		case 86:
			setPushImg("img_paste");
			break;

		default:
			break;
	}
}

/**
 * キー入力。
 *
 * @param event イベント
 */
function setImgInputShift(event){
	var key = event.keyCode;

	// opera対応
	var flgOpera = false;
	if($("img_paste").className == "hide"){
		flgOpera = true;
	}

	switch(key){
		// "="
		case 189:
			setPushBtn("btn_equal");
			break;

		// "*"
		case 186:
		case 58: // opera対応
			setPushBtn("btn_multi");
			break;

		// "+"
		case 187:
		case 59: // opera対応
			setPushBtn("btn_add");
			break;

		// "%"
		case 53:
			setPushBtn("btn_persent");
			break;

		// "Shift + Ins"
		case 45:
			if(flgOpera){
				setPushBtn("btn_equal");
			} else {
				setPushImg("img_paste");
			}
			break;

		default:
			break;
	}
}

/**
 * キー入力。
 *
 * @param event イベント
 */
function doInput(event){
	if(event == null){
		event = window.event;
	}
	var key = event.keyCode;

	// Altが押されている
	if(event.altKey){
		return;
	}

	// コントロールが押されている
	if(event.ctrlKey){
		doInputCtrl(event);
		return;
	}

	// シフトが押されている
	if(event.shiftKey){
		doInputShift(event);
		return;
	}

	switch(key){
		// "="
		case 13:
			doCalc();
			clearPushBtn("btn_equal");
			break;

		// "C"
		case 27:
		case 46:
			doClear();
			clearPushBtn("btn_clear");
			break;

		// "Back"
		case 8:
			doBack();
			clearPushBtn("btn_back");
			break;

		// "/"
		case 191:
		case 111:
		case 47: // opera対応
			addSign("/");
			clearPushBtn("btn_div");
			break;

		// "*"
		case 106:
		case 42: // opera対応
			addSign("*");
			clearPushBtn("btn_multi");
			break;

		// "-"
		case 109:
		case 189:
		case 45: // opera対応
			addSign("-");
			clearPushBtn("btn_sub");
			//break;
		// "="
		//case 189:
		case 45: // opera対応
			clearPushBtn("btn_equal");
			break;

		// "+"
		case 107:
		case 43: // opera対応
		case 61: // opera対応(mac opera)
			addSign("+");
			clearPushBtn("btn_add");
			break;

		// テンキー(数字)
		case  96:
		case  97:
		case  98:
		case  99:
		case 100:
		case 101:
		case 102:
		case 103:
		case 104:
		case 105:
			key = key - 48;

		// 数字
		case 48:
		case 49:
		case 50:
		case 51:
		case 52:
		case 53:
		case 54:
		case 55:
		case 56:
		case 57:
			var value = String.fromCharCode(key);
			addNumber(value);
			clearPushBtn("btn_" + value);
			if(key == 53){
				clearPushBtn("btn_persent");
			}
			//break;
		// "%"
		//case 53:
			clearPushBtn("btn_persent");
			break;

		// "."
		case 110:
		case 190:
		case 46: // opera対応
		case 78: // opera対応
			addNumber(".");
			clearPushBtn("btn_dott");
			break;

		// Ctlだけ離されたときの対応
		// "Ctrl + C"
		case 67:
		// "Ctrl + Ins"
		// "Shift + Ins"
		case 45:
			clearPushImg("img_copy");
			clearPushImg("img_paste");
			break;

		// "Ctrl + V"
		case 86:
			clearPushImg("img_paste");
			break;

		// "*"
		case 186:
		case 58: // opera対応
			clearPushBtn("btn_multi");
			break;

		// "+"
		case 187:
		case 59: // opera対応
			clearPushBtn("btn_add");
			break;

		default:
			break;
	}
}

/**
 * キー入力。
 *
 * @param event イベント
 */
function doInputCtrl(event){
	var key = event.keyCode;

	switch(key){
		// "Ctrl + C"
		case 67:
		// "Ctrl + Ins"
		case 45:
			doCopy();
			clearPushImg("img_copy");
			break;

		// "Ctrl + V"
		case 86:
			doPaste();
			clearPushImg("img_paste");
			break;

		default:
			break;
	}
}

/**
 * キー入力。
 *
 * @param event イベント
 */
function doInputShift(event){
	var key = event.keyCode;

	// opera対応
	var flgOpera = false;
	if($("img_paste").className == "hide"){
		flgOpera = true;
	}

	switch(key){
		// "="
		case 189:
			doCalc();
			clearPushBtn("btn_equal");
			break;

		// "*"
		case 186:
		case 58: // opera対応
			addSign("*");
			clearPushBtn("btn_multi");
			break;

		// "+"
		case 187:
		case 59: // opera対応
			addSign("+");
			clearPushBtn("btn_add");
			break;

		// "%"
		case 53:
			doPersent();
			clearPushBtn("btn_persent");
			break;

		// "Shift + Ins"
		case 45:
			if(flgOpera){
				doCalc();
				clearPushBtn("btn_equal");
			} else {
				doPaste();
				clearPushImg("img_paste");
			}
			break;

		default:
			break;
	}
}

/**
 * 設定画面が表示されたとき。
 */
function doSetting(){
	// 特になし
}

/**
 * 設定画面が閉じられた時。
 */
function doSettingClosed(){
	// 設定情報の読込み
	readData();

	if(flgOnDoc){
		showOnDoc();
	} else {
		showUnDoc();
	}
}

/**
 * フォーカス設定。
 */
function setFocus(){
	// ボタンが連打できないようにする
	//$("bdy_calc").focus();
	$("txt_calc").focus();
}

/**
 * 押下されたときのボタン設定。
 *
 * @param target 対象ID
 */
function setPushBtn(target){
	var element = $(target);
	if(element == null){
		return;
	}

	// デフォルトクラス名の保存
	var className = mapClass[target];
	if(className == null){
		mapClass[target] = element.className;
	}

	element.className = "pushBtn";
}

/**
 * 離されたときのボタン設定。
 *
 * @param target 対象ID
 */
function clearPushBtn(target){
	var element = $(target);
	if(element == null){
		return;
	}

	// デフォルトクラス名の取得
	var className = mapClass[target];
	if(className == null){
		return;
	}

	element.className = className;
}

/**
 * 押下されたときのイメージ設定。
 *
 * @param target 対象ID
 */
function setPushImg(target){
	var element = $(target);
	if(element == null || element.className == "hide"){
		return false;
	}

	// デフォルトクラス名の保存
	var className = mapClass[target];
	if(className == null){
		mapClass[target] = element.className;
	}

	element.className = "pushImg";
	return true;
}

/**
 * 離されたときのイメージ設定。
 *
 * @param target 対象ID
 */
function clearPushImg(target){
	clearPushBtn(target);
}

/**
 * 結果表示。
 *
 * @param ans 表示数値
 */
function showCalc(ans){
	if(settingData.camma){
		// カンマをつける
		ans = appendCamma(ans);
	}

	$("txt_calc").value = ans;
}

/**
 * スライドバーにドックされたとき。
 */
function showOnDoc(){
	$("div_calc").className = settingData.bg;

	var index = settingData.bg.substring(settingData.bg.length - 1);
	$("txt_calc").className = "onInput" + index;
	$("img_copy").src       = IMG_SRC_COPY1  + index + IMG_SRC_COPY2;
	$("img_paste").src      = IMG_SRC_PASTE1 + index + IMG_SRC_PASTE2;

	flgOnDoc = true;
}

/**
 * スライドバーからアンドックされたとき。
 */
function showUnDoc(){
	$("div_calc").className = "unDoc";

	var index = settingData.bg.substring(settingData.bg.length - 1);
	$("txt_calc").className = "onInput" + index;
	$("img_copy").src       = IMG_SRC_COPY1  + index + IMG_SRC_COPY2;
	$("img_paste").src      = IMG_SRC_PASTE1 + index + IMG_SRC_PASTE2;

	flgOnDoc = false;
}

/**
 * 有効桁数チェック。
 *
 * @param  num チェック値
 * @return     有効桁数を満たした値
 */
function checkMaxLengthString(value){
	var positive = null;
	var negative = null;

	// 有効桁数チェック
	var indexDecimal = value.indexOf(".");
	if(indexDecimal >= 0){
		positive = value.substring(0, indexDecimal);
		negative = value.substring(indexDecimal);
	} else {
		positive = value;
		negative = "";
	}

	if(positive.length > MAX_POSITIVE_LENGTH){
		positive = positive.substring(0, MAX_POSITIVE_LENGTH);
	}
	if(negative.length > MAX_NEGATIVE_LENGTH){
		negative = negative.substring(0, MAX_NEGATIVE_LENGTH);
	}

	return positive + negative;
}

/**
 * 有効桁数チェック。
 *
 * @param  num チェック値
 * @return     有効桁数を満たした値
 */
function checkMaxLength(num){
	var ans = checkMaxLengthString(String(num));

	return new Number(ans);
}

/**
 * カンマをつける。
 *
 * @param  value 元値
 * @return       カンマを付加した値
 */
function appendCamma(value){
	if(value == null || value.length <= 3){
		return value;
	} else {
		value = value.toString();
	}
	var sign    = "";
	var decimal = "";

	// 記号を取り除く
	var indexSign = value.indexOf("-");
	if(indexSign >= 0){
		sign  = value.substring(0, indexSign + 1);
		value = value.substring(indexSign + 1);
	}

	// 小数点以下を取り除く
	var indexDecimal = value.indexOf(".");
	if(indexDecimal >= 0){
		decimal = value.substring(indexDecimal);
		value   = value.substring(0, indexDecimal);
	}

	// カンマをつける
	var newCnt   = 0;
	var newValue = "";
	for(var cnt = value.length ; cnt > 0 ; cnt--){
		if(newCnt != 0 && newCnt % 3 == 0){
			newValue = "," + newValue;
		}

		newValue = value.charAt(cnt - 1) + newValue;
		newCnt++;
	} // for(var cnt = value.length ; cnt >= 0 ; cnt--)

	return sign + newValue + decimal;
}

/**
 * 数値の計算。
 *
 * @param  value 計算式
 * @return       計算結果
 */
function calculate(value){
	var ans = Number.NaN;

	try{
		// 計算処理
		ans = eval(value);

	}catch(ex){
		// エラー
		ans = Number.NaN;

	} finally {
		// 有効数値チェック
		var flgAns = isNaN(ans);
		if(
			flgAns
			|| ans == Number.POSITIVE_INFINITY
			|| ans == Number.NEGATIVE_INFINITY
		){
			ans = null;
		}
	}

	// 小数点補正
	var tmpAnsStr    = String(ans);
	var indexDecimal = tmpAnsStr.indexOf(".");
	if(indexDecimal >= 0){
		var tmpAns1 = ans * Math.pow(10, MAX_NEGATIVE_LENGTH - 1);
		var tmpAns2 = Math.round(tmpAns1) * 10;
		ans = tmpAns2 * Math.pow(10, MAX_NEGATIVE_LENGTH * -1);
	} // if(indexDecimal >= 0)

	// 有効桁数チェック
	if(ans != null){
		ans = checkMaxLength(ans);
	}

	return ans;
}

/**
 * 設定情報の初期化。
 */
function initSettingData(){
	$("img_copy").alt    = getLocalizedString("IMG_ALT_COPY");
	$("img_paste").alt   = getLocalizedString("IMG_ALT_PASTE");
	$("img_copy").title  = getLocalizedString("IMG_ALT_COPY");
	$("img_paste").title = getLocalizedString("IMG_ALT_PASTE");

	$("btn_clear").className   = "btnCalc";
	$("btn_minus").className   = "btnCalc";
	$("btn_persent").className = "btnCalc";
	$("btn_back").className    = "btnCalc";
	$("btn_equal").className   = "btnCalc";
	$("btn_div").className     = "btnCalc";
	$("btn_multi").className   = "btnCalc";
	$("btn_sub").className     = "btnCalc";
	$("btn_add").className     = "btnCalc";

	// コピー&ペーストできないのは非表示にする
	var txtTmp = $("txt_tmp");
	if(
		!txtTmp.createTextRange
		|| !txtTmp.createTextRange().execCommand
	){
		if(isDashboard()){
			txtTmp.className   = "hide";

		} else {
			var imgCopy  = $("img_copy");
			var imgPaste = $("img_paste");
			//var txtTmp   = $("txt_tmp");

			imgCopy.className  = "hide";
			imgPaste.className = "hide";
			txtTmp.className   = "hide";
		} // if(isDashboard())
	}

	// 画面表示の設定
	if(flgOnDoc){
		showOnDoc();
	} else {
		showUnDoc();
	}
}

/**
 * 更新チェックするか。
 *
 * @return 更新チェックするときにはtrue
 */
function isCheckUpdate(){
	var flgChkUpd = false;

	// 未チェックだったら必ずtrue
	if(settingData.chkUpdTime <= 0){
		return true;
	}

	// 更新イメージ表示中だったら必ずtrue
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		return true;
	}

	var nowDate   = new Date();
	var nextDate  = new Date(settingData.chkUpdTime);

	// 1ヶ月後を設定
	nextDate.setMonth(nowDate.getMonth() + UPDATE_INTERVAL_MONTH);

	if(nowDate.getTime() > nextDate.getTime()){
		// 更新チェックを行う
		flgChkUpd = true;
	}

	return flgChkUpd;
}

/**
 * 更新なしイメージの設定。
 */
function showUpdateNon(){
	var aUpd = $("a_upd");
	if(aUpd == null){
		var imgUpd = $("img_upd");
		imgUpd.src   = IMG_SRC_UPDATE_NON;
		imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NON");
		imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NON");

	} else {
		var divUpd     = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML
			= '<img src="' + IMG_SRC_UPDATE_NON + '" name="img_upd" id="img_upd" '
			+ 'alt="' + getLocalizedString("IMG_ALT_UPDATE_NON") + '" '
			+ 'title="' + getLocalizedString("IMG_ALT_UPDATE_NON") + '" border="0">';
	}
}

/**
 * チェック中イメージの設定。
 */
function showUpdateNow(){
	var aUpd = $("a_upd");
	if(aUpd == null){
		var imgUpd = $("img_upd");
		imgUpd.src   = IMG_SRC_UPDATE_NOW;
		imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NOW");
		imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NOW");

	} else {
		var divUpd     = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML
			= '<img src="' + IMG_SRC_UPDATE_NOW + '" name="img_upd" id="img_upd" '
			+ 'alt="' + getLocalizedString("IMG_ALT_UPDATE_NOW") + '" '
			+ 'title="' + getLocalizedString("IMG_ALT_UPDATE_NOW") + '" border="0">';
	}
}

/**
 * 更新イメージの設定。
 */
function showUpdate(){
	var imgUpd = $("img_upd");
	imgUpd.src   = IMG_SRC_UPDATE;
	imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE");
	imgUpd.title = getLocalizedString("IMG_ALT_UPDATE");

	var aUpd = $("a_upd");
	if(aUpd == null){
		// dashboard対応
		var onclickFnuc = "";
		if(isDashboard()){
			onclickFnuc = ' onclick="window.widget.openURL(this.href); return false;"';
		} // if(isDashboard())

		var divUpd = $("td_upd");
		var imgUpdHtml = divUpd.innerHTML;
		divUpd.innerHTML = '<a id="a_upd" href="' + settingData.chkUpdUrl +'"' + onclickFnuc + '>' + imgUpdHtml + '</a>';
	} else {
		aUpd.href = settingData.chkUpdUrl;
	}
}

/**
 * 更新チェック。
 * 更新チェックはPC起動時または1日毎に行う。
 */
function checkUpdate(){
	if(updChkIid != null){
		clearTimeout(updChkIid);
		updChkIid = null;
	}

	try{
		doCheckUpdate();
	}catch(ex){
	}
	updChkIid = setTimeout('checkUpdate()', UPDATE_CEHCK_INTERVAL_TIME);
}

/**
 * 更新表示。
 */
function doCheckUpdate(){
	// 更新イメージの初期設定
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}

	// 更新チェックするか
	var flgChkUpd = isCheckUpdate();
	if(!flgChkUpd){

		// 今回は更新チェックを行わない
		return;
	}

	// 現在のバージョンの取得
	var nowVer = getVersion();
	if(nowVer == null || nowVer == ""){

		// 今回は更新チェックを行わない
		return;
	}

	// 更新イメージをチェック中にする
	showUpdateNow();

	// Firefox対応
	try{
		if(netscape){
			netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
		}
	}catch (ex){
	}

	var updateUrl = null;
	if(isOpera()){
			updateUrl = OPERA_UPDATE_URL;

	} else if(isDashboard()){
		updateUrl = DASHBOARD_UPDATE_URL;

	} else if(isSBM()){
		updateUrl = SBM_UPDATE_URL;

	} else {
		updateUrl = VISTA_UPDATE_URL;
	}

/*
	// 非同期だとうまく動作しない
	var chkUpdReq = new Ajax.Request(
		updateUrl, {
			method       : "get",
			parameters   : "name=" + GADGET_NAME + "&version=" + nowVer + "&time=" + new Date().getTime(),
//			onLoaded     : function(){
//				// 更新イメージをチェック中にする
//				var imgUpd = $("img_upd");
//				imgUpd.src   = IMG_SRC_UPDATE_NOW;
//				imgUpd.alt   = getLocalizedString("IMG_ALT_UPDATE_NOW");
//				imgUpd.title = getLocalizedString("IMG_ALT_UPDATE_NOW");
//			},
			//onComplete   : showCheckUpdate,
			asynchronous : false,
			onFailure    : checkUpdateError,
			onException  : checkUpdateException
		}
	);
*/

	// 最新バージョンの取得
	var parameters = "name=" + GADGET_NAME + "&version=" + nowVer + "&time=" + new Date().getTime();
	var resTxt     = null;
	try{
		// Ajax通信
		// 非同期だとうまく動作しない
		resTxt = ajax.gets(updateUrl + "?" + parameters);

	}catch(ex){
		checkUpdateError(ex);
		return;
	}

	// レスポンスを作成
/*
	var chkUpdRes = new Ajax.Response(chkUpdReq);
	showCheckUpdate(chkUpdRes);
*/
	showCheckUpdate(resTxt);
}

/**
 * 更新表示。
 *
 * @param resTxt レスポンスオブジェクト
 */
function showCheckUpdate(resTxt){
	var flgUpd = false;

	// 更新チェックデータの取得
	var chkUpdData = null;
	if(resTxt != null){
		try{
			//chkUpdData = resTxt.evalJSON();
			chkUpdData = JSON.parse(resTxt);

		}catch(ex){
			checkUpdateException(ex);
			return;
		}
	}

	if(
		chkUpdData == null
		|| chkUpdData[GADGET_NAME] == null
	){
		// 更新イメージを元に戻す
		if(
			settingData.chkUpdUrl != null
			&& settingData.chkUpdUrl != ""
		){
			showUpdate();

		} else {
			showUpdateNon();
		}
		return;
	}

	// 現在のバージョンの取得
	var nowVer = getVersion();
	if(nowVer == null || nowVer == ""){

		// 今回は更新チェックを行わない
		// 更新イメージを元に戻す
		if(
			settingData.chkUpdUrl != null
			&& settingData.chkUpdUrl != ""
		){
			showUpdate();

		} else {
			showUpdateNon();
		}
		return;
	}

	// バージョンチェック
	if(nowVer != chkUpdData[GADGET_NAME].version){
		var nowVerList = nowVer.split(".");
		var updVerList = chkUpdData[GADGET_NAME].version.split(".");
		for(var cnt = 0 ; cnt < nowVerList.length ; cnt++){
			if(cnt >= updVerList.length){
				break;
			}

			var nowVerSub = parseInt(nowVerList[cnt]);
			var updVerSub = parseInt(updVerList[cnt]);
			if(nowVerSub < updVerSub){
				flgUpd = true;
				break;

			} else if(nowVerSub > updVerSub){
				break;
			}
		} // for(var cnt = 0 ; cnt < nowVerList.length ; cnt++)
	}

	// 更新イメージ設定
	if(flgUpd){
		settingData.chkUpdUrl = chkUpdData[GADGET_NAME].url;

		// 更新イメージにする
		showUpdate();

	} else {
		settingData.chkUpdUrl = null;

		// 更新なしイメージにする
		showUpdateNon();
	}


	// 更新チェック日付の更新
	settingData.chkUpdTime = new Date().getTime();
	writeData();
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function checkUpdateError(res){
	// 更新イメージを元に戻す
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}
}

/**
 * Ajaxエラー。
 *
 * @param res レスポンスオブジェクト
 */
function checkUpdateException(res, ex){
	// 更新イメージを元に戻す
	if(
		settingData.chkUpdUrl != null
		&& settingData.chkUpdUrl != ""
	){
		showUpdate();

	} else {
		showUpdateNon();
	}
}

/**
 * 音を鳴らします。
 */
function doSoundBeep(){
	try{
		System.Sound.beep();
	}catch(ex){
	}
}

/**
 * バージョン情報の取得。
 */
function getVersion(){
	var ver = "";

	try{
		//ver = System.Gadget.version;
		ver = VERSION;

	}catch(ex){
	}

	return ver;
}

/**
 * 設定情報の読込み。
 *
 * @return 読込んだ設定情報
 */
function getReadData(){
	var readValue = null;

	try{
		if(!isVista()){
			readValue = widget.preferenceForKey(SETTING_NAME);

		} else {
			readValue = System.Gadget.Settings.readString(SETTING_NAME);
		}
	}catch(ex){
	}

	var readData_ = null;
	if(readValue != null && readValue != ""){
		try{
			//readData_ = readValue.evalJSON();
			readData_ = JSON.parse(readValue);

		}catch(ex){
		}
	}

	return readData_;
}

/**
 * 設定情報の読込み。
 */
function readData(){
	var readData_ = getReadData();

	if(readData_ != null && readData_ != ""){
		settingData = readData_;
	}
}

/**
 * 設定情報の書込み。
 *
 * @param writeData 書込む設定情報
 */
function setWriteData(writeData){
	try{
		//var writeValue = Object.toJSON(writeData);
		var writeValue = JSON.stringify(writeData);

		if(!isVista()){
			widget.setPreferenceForKey(writeValue, SETTING_NAME);

		} else {
			System.Gadget.Settings.writeString(SETTING_NAME, writeValue);
		}
	}catch(ex){
	}
}

/**
 * 設定情報の書込み。
 */
function writeData(){
	setWriteData(settingData);
}

/**
 * 初期処理。
 */
function init(){
	setEventListener();
	setGadgetEventListener();
	readData();

	// ソフトバンクモバイルかの判定
	if(!isSBM()){

		// 設定画面の読込み
		$("if_setting").src = "calc-setting.html";

	} else {
		setMobilePhone();
	}

	// 画面表示の設定
	setLocalized(settingData.lang);
	initSettingData();
	if(FLG_UPDATE){
		checkUpdate();
	}
	setFocus();
}

/**
 * イベントリスナーの設定。
 */
function setEventListener(){
	// キー入力の設定
	document.onkeyup = doInput;

	// onclickの設定
	$("btn_equal").onclick   = function(){ doCalc();    setFocus(); };
	$("btn_back").onclick    = function(){ doBack();    setFocus(); };
	$("btn_clear").onclick   = function(){ doClear();   setFocus(); };
	$("btn_minus").onclick   = function(){ doMinus();   setFocus(); };
	$("btn_persent").onclick = function(){ doPersent(); setFocus(); };

	$("img_copy").onclick    = function(){ doCopy();  setFocus(); };
	$("img_paste").onclick   = function(){ doPaste(); setFocus(); };

	$("btn_div").onclick   = function(){ addSign("/"); setFocus(); };
	$("btn_multi").onclick = function(){ addSign("*"); setFocus(); };
	$("btn_sub").onclick   = function(){ addSign("-"); setFocus(); };
	$("btn_add").onclick   = function(){ addSign("+"); setFocus(); };

	$("btn_0").onclick    = function(){ addNumber("0"); setFocus(); };
	$("btn_1").onclick    = function(){ addNumber("1"); setFocus(); };
	$("btn_2").onclick    = function(){ addNumber("2"); setFocus(); };
	$("btn_3").onclick    = function(){ addNumber("3"); setFocus(); };
	$("btn_4").onclick    = function(){ addNumber("4"); setFocus(); };
	$("btn_5").onclick    = function(){ addNumber("5"); setFocus(); };
	$("btn_6").onclick    = function(){ addNumber("6"); setFocus(); };
	$("btn_7").onclick    = function(){ addNumber("7"); setFocus(); };
	$("btn_8").onclick    = function(){ addNumber("8"); setFocus(); };
	$("btn_9").onclick    = function(){ addNumber("9"); setFocus(); };
	$("btn_dott").onclick = function(){ addNumber("."); setFocus(); };

	document.onkeydown = function(){ setImgInput(event); setFocus(); };
	$("img_copy").onmousedown  = function(){ setPushImg("img_copy"); setFocus(); };
	$("img_copy").onmouseup    = function(){ clearPushImg("img_copy"); };
	$("img_copy").onmouseout   = function(){ clearPushImg("img_copy"); };
	$("img_paste").onmousedown = function(){ setPushImg("img_paste"); setFocus(); };
	$("img_paste").onmouseup   = function(){ clearPushImg("img_paste"); };
	$("img_paste").onmouseout  = function(){ clearPushImg("img_paste"); };
}

/**
 * ガジェットイベントリスナーの設定。
 */
function setGadgetEventListener(){
	try{
		flgOnDoc = System.Gadget.docked;

		// ドックの状態設定
		System.Gadget.onDock   = showOnDoc;
		System.Gadget.onUndock = showUnDoc;

		// 設定画面の設定
		System.Gadget.settingsUI        = "calc-setting.html";
		System.Gadget.onShowSettings    = doSetting;
		System.Gadget.onSettingsClosed  = function(){ doSettingClosed(); setFocus(); };

	}catch(ex){
		// ツールバーの表示
		$("td_setting").className = "";

		//// 最大化ボタン(unDoc)
		//$("btn_max").onclick = function(){
		//	if(flgOnDoc){
		//		showUnDoc();
		//	} else {
		//		showOnDoc();
		//	}
		//};

		// 設定ボタン
		if(!!window.JSON){
			$("btn_conf").onclick = function(){
				doSetting();
				$("if_setting").className = "";
				//$("btn_max").className    = "hide";
				$("div_calc").className   = "hide";

				if(isMobile()){
					window.resizeTo(WINDOW_SETTING_MOBILE_WIDTH, WINDOW_SETTING_MOBILE_HEIGHT);
				} else {
					window.resizeTo(WINDOW_SETTING_WIDTH, WINDOW_SETTING_HEIGHT);
				} // if(isMobile())
			}

		} else {
			$("btn_conf").className = "hide";
		}

		if(isOpera()){
				// 閉じるボタン
				$("btn_close").onclick = function(){
					window.close();
				};

		} else {
			$("btn_close").className = "hide";
		}
	}
}

/**
 * ソフトバンクモバイル用設定。
 */
function setMobilePhone(){
	FLG_UPDATE = false;
	$("div_toolbar").className = "hide";
	$("img_copy").className    = "hide";
	$("img_paste").className   = "hide";
	$("txt_tmp").className     = "hide";
}

// 初期処理
document.body.onload = init();

